#include "fivewin.ch"
#include "calendar.ch"

FUNCTION TestClndr()

   LOCAL oCal, oWnd
   LOCAL dDate     := Date()
   LOCAL lSunday   := .T.
   LOCAL lSaturday := .T.

   DEFINE DIALOG oWnd2 RESOURCE "CALENDAR2"

   REDEFINE CALENDAR oCal VAR dDate OF oWnd2 ID 2010

    ACTIVATE DIALOG oWnd2 ON INIT InitState( oCal, lSunday, lSaturday )

RETURN NIL


FUNCTION InitState( oCal, lSunday, lSaturday )
    OnGetState( oCal, lSunday, lSaturday )
    oCal:SetDayState()
    oCal:bOnGetState = { | oCal | OnGetState( oCal, lSunday, lSaturday ) }

RETURN NIL

Function OnGetState( oCal, lSun, lSat )
   LOCAL i, imax, j, jmax, nDay, nDayState, nMonth
   LOCAL dStartDate
   LOCAL dCurrentDay := oCal:dDate

   oCal:GetMonthRange()

   dStartDate = oCal:dDate
     MsgInfo( dStartDate )
   imax   := Len( oCal:aDayState )
   nMonth := Month( dStartDate )
     MsgInfo( nMonth )

   FOR i:=1 TO imax
      nDayState := 0

      FOR j:=1 TO 31
         nDay := DoW( dStartDate ) - 2
         IF nDay < 0
            nDay += 7
         ENDIF

         IF nDay == 5 .AND. lSat
            oCal:SetArrayDayState( i, j )
         ENDIF

         IF nDay == 6 .AND. lSUN
            oCal:SetArrayDayState( i, j )
         ENDIF

         dStartDate ++

         IF Month( dStartDate ) <> nMonth
            EXIT
         ENDIF
      NEXT

      nMonth       := Month( dStartDate )
   NEXT

   oCal:SetDate( dCurrentDay )

return nil

